# File: PloneLinkCheckerTool.py
# 
# Copyright (c) 2006 by Vincent Bonamy
# Generator: ArchGenXML Version 1.4.0-final 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Vincent Bonamy <vbonamy@gmail.com>, Chistine Monnet
<christine.monnet@insa-rouen.fr>, Maxime Reynet <maxime.reynet@insa-rouen.fr>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



# additional imports from tagged value 'import'
from Products.DataGridField.DataGridField import DataGridField
from Products.DataGridField.DataGridWidget import DataGridWidget
from Products.DataGridField.Column import Column
from Products.DataGridField.SelectColumn import SelectColumn

from Products.PloneLinkChecker.config import *

from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here

import HTMLParser, urllib2, socket
# timeout in seconds - maybe it must be configurable ...
timeout = 5
socket.setdefaulttimeout(timeout)
from Products.CMFCore.utils import getToolByName

##/code-section module-header

schema=Schema((
    DataGridField('typesFields',
        widget=DataGridWidget(
            columns= {'types' : SelectColumn('Plone Objects Types', vocabulary='getTypes'), 'fields': SelectColumn('Plone Objects Fields', vocabulary='getFields')},
            label='Typesfields',
            label_msgid='PloneLinkChecker_label_typesFields',
            description_msgid='PloneLinkChecker_help_typesFields',
            i18n_domain='PloneLinkChecker',
        ),
        columns= ('types', 'fields')
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PloneLinkCheckerTool_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PloneLinkCheckerTool(UniqueObject,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'PloneLinkCheckerTool'

    meta_type                  = 'PloneLinkCheckerTool'
    portal_type                = 'PloneLinkCheckerTool'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'PloneLinkCheckerTool.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "PloneLinkCheckerTool"
    typeDescMsgId              = 'description_edit_plonelinkcheckertool'

    actions =  (


       {'action':      "string:${object_url}/plonelinkchecker_view",
        'category':    "object",
        'id':          'view',
        'name':        'view',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


    )
    toolicon                   = 'searchlink_icon.gif'

    schema = PloneLinkCheckerTool_schema

    ##code-section class-header #fill in your manual code here

    # links_check_results is a list of dictionnaries
    # links_check_results = [{'obj.absolute_url':'', 'obj.field':'', 'link':'', 'http_code':''}, ...]
    links_check_results = []
    
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_plonelinkcheckertool')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    #Methods

    security.declarePublic('getLinksForHTML')
    def getLinksForHTML(self,html):
        """
        
        """
        class htmlparser(HTMLParser.HTMLParser):
            def __init__(self):
                HTMLParser.HTMLParser.__init__(self)
                self.links = []
            def handle_starttag(self, tag, attrs):
                url=None
                if tag=='a' and dict(attrs).has_key('href'):
                    url = dict(attrs)['href']
                if tag=='img' and dict(attrs).has_key('src'):
                    url = dict(attrs)['src']
                if url:
                    self.links.append(url)



        parser = htmlparser()
        parser.feed(html)

        return parser.links



    security.declarePublic('checkLink')
    def checkLink(self, link):
        """
        
        """
        code = ''
        try:
            f = urllib2.urlopen(link)
            code = f.headers.status
        except urllib2.HTTPError, e:
            code = e.code
        except:
            code = 'timeout?'            

        if code == '':
            code = 200
            
        return code



    security.declarePublic('update')
    def update(self, REQUEST=None):
        """
        
        """
        cat = self.portal_catalog
        self.links_check_results = []

        for type_field in self.getTypesFields():
            ptype = type_field['types']
            pfield = type_field['fields']
            brains = cat.searchResults(portal_type=ptype)
            for brain in brains:
                obj = brain.getObject()
                try:
                    obj = obj.aq_explicit
                except:
                    pass
                field_value = getattr(obj, pfield, '')
                if callable(field_value):
                    field_value = field_value()
                    links = self.getLinksForHTML(field_value)
                    links = self.getAbsolutePathes(obj, links)
                    for link in links:
                        # links_check_results = [['obj.absolute_url', 'obj.field', 'link', 'http_code'], ...]
                        link_check = {}
                        link_check['title'] = obj.title_or_id()
                        link_check['type'] = obj.portal_type
                        link_check['absolute_url'] = obj.absolute_url()
                        link_check['field'] = pfield
                        link_check['link'] = link
                        link_check['code'] = self.checkLink(link)
                        
                        self.links_check_results.append(link_check)
                        
            self.links_check_results.sort(lambda x,y : cmp(x['code'],y['code']))
            self.links_check_results.reverse()
            

        if REQUEST is not None:
            return self.view()
        


    security.declarePublic('getTypes')
    def getTypes(self):
        """
        
        """
        at_tool=getToolByName(self,'archetype_tool')
        at_types=at_tool.listRegisteredTypes()        
        at_list=[]
        for at in at_types:
            at_list.append(at['portal_type'])
        at_list.sort()
        return DisplayList(zip(at_list, at_list))



    security.declarePublic('getFields')
    def getFields(self):
        """
        
        """
        fields = []
        at_tool=getToolByName(self,'archetype_tool')
        at_types=at_tool.listRegisteredTypes()
        for at in at_types:
                for field in at['schema'].fields():
                    if field.accessor not in fields and field.accessor != None:
                        fields.append(field.accessor)
        fields.sort()
        #import pdb; pdb.set_trace()
        return DisplayList(zip(fields, fields))        


    #manually created methods

    def getAbsolutePathes(self, obj, links):
        abs_links=[]
        for link in links:
            if 'mailto:' in link:
                continue
            if 'http' not in link:
                path = obj.absolute_url()
                path = path[:path.rfind('/')+1]
                link = path + link
            abs_links.append(link)
        return abs_links


    def getFieldsTypes(self,):
        return {'types':self.getTypes(), 'fields':self.getFields()}



registerType(PloneLinkCheckerTool,PROJECTNAME)
# end of class PloneLinkCheckerTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer




